unit uFidoRoutine;
//      
interface

//  Address (2:5030/922.20)  "": 2, 5030, 922, 20
procedure ExplodeAddress(Address: String; out a1,a2,a3,a4: Word);


//     
//   ( str  ,     Default)
function SafeStrToInt(const Str: String; Default: Integer = 0): Integer;


//    Win-  ASCII-
function WinToASCII(const S: String): String;

//    ASCII-  Win-
function ASCIIToWin(const S: String): String;


implementation
uses SysUtils;

//  :     Address
procedure ExplodePoint(var Address: String; c: char; out a: Word);
var p: Integer;
begin
  a := 0;
  if Address='' then exit;
  p := Pos(c,Address);
  if p=0 then p:=Length(Address)+1;
  a := SafeStrToInt(copy(Address,1,p-1));
  Delete(Address,1,p);
end;

//     ':', '/', '.'  ' '
procedure ExplodeAddress(Address: String; out a1,a2,a3,a4: Word);
begin
  Address := Trim(Address)+' ';
  ExplodePoint(Address,':',a1);
  ExplodePoint(Address,'/',a2);
  ExplodePoint(Address,'.',a3);
  ExplodePoint(Address,' ',a4);
end;


//   ... :)
function SafeStrToInt(const Str: String; Default: Integer): Integer;
var Code: Integer;
begin
 val(Str,Result,Code);
 if Code<>0 then Result:=Default;
end;


function WinToASCII(const S: String): String;
begin
  if S='' then Result := ''
  else
    begin
     SetLength(Result,Length(S));
     CharToOEM(PChar(S),PChar(Result));
    end;
end;

function ASCIIToWin(const S: String): String;
begin
  if S='' then Result := ''
  else
    begin
     SetLength(Result,Length(S));
     OEMToChar(PChar(S),PChar(Result));
    end;
end;

end.
